mod Ex06b

incl Mtex

incl Maux

loc rem 
  \para \bf  6. CVICENIE Z PREDMETU 1-INF-465 DEKLARATIVNE PROGRAMOVANIE  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end utorok 18.3.2008 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-465-dp/0708ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane zoznamom. Zadanie 
  sa sklada z tychto suborov: 
  \items 
   \item \para Subory \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subory \it  maux*.cl  \end obsahuje definicie niektorych funkcii 
         a predikatov. 
   \item \para Subory \it  ex*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] Remark.  \end The module \it  Msyntax  \end in the file \it  
  msyntax.cl  \end contains the syntax of the system CL. 

rem 
  \para \bf  Chapter. Programs Operating on Lists.  \end 

rem 
  \para \bf  Section. Sorting of Lists.  \end 

rem 
  \para \bf  Permutations.  \end 

pred/2 Perm 'Tex2_sim'
  Perm(x,y) <-> \a a Count(a,x) = Count(a,y)

rem 
  \para \bf  Ordered lists.  \end 

pred Ord 
  Ord(x) <-> \a i\a j(i < j & j < L(x) -> Sub(x,i) <= Sub(x,j))

rem 
  \para \bf  Insertion sort.  \end 

rem 
  \para \bf  Exercise.  \end \header* fun/2 Insert  \end Define the function 
  \ft Insert(a,x) \end such that 
  \eq* 
    Perm(Insert(a,x),a,x)
  \end
  \eq* 
    Ord(x) -> Ord Insert(a,x)
  \end

fun/2 Insert 
  Insert(a,x) = Foo

rem 
  \para \bf  Exercise.  \end Implement insertion sort; that is, define the 
  function \ft Isort(x) \end such that 
  \eq* 
    Perm(Isort(x),x)
  \end
  \eq* 
    Ord Isort(x)
  \end
  \para with the help of \ft Insert(a,x) \end. 

fun Isort 
  Isort(x) = Foo

rem 
  \para \bf  Merge sort.  \end 

rem 
  \para \bf  Exercise.  \end Define the function \ft Msplit(x) \end such that 
  \eq* 
    \e y\e z Msplit(x) = y,z
  \end
  \eq* 
    Msplit(x) = y,z -> Perm(x,y++z)
  \end
  \eq* 
    Msplit(x) = y,z -> L(y) = L(z) \/ L(y) = L(z)+1
  \end

fun Msplit 
  Msplit(x) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun/2 Merge  \end Define the function 
  \ft Merge(x,y) \end such that 
  \eq* 
    Perm(Merge(x,y),x++y)
  \end
  \eq* 
    Ord(x) & Ord(y) -> Ord Merge(x,y)
  \end

fun/2 Merge 
  Merge(x,y) = Foo

rem 
  \para \bf  Exercise.  \end Implement merge sort; that is, define the function 
  \ft Msort(x) \end such that 
  \eq* 
    Perm(Msort(x),x)
  \end
  \eq* 
    Ord Msort(x)
  \end
  \para with the help of \ft Msplit(x) \end and \ft Merge(x,y) \end. 

fun Msort 
  Msort(x) = Foo

